package main

import (
	"net"

	initialize "im-microservice/initialization"

	beeLogger "github.com/beego/bee/logger"
)

const (
	Address string = "127.0.0.1:8000"
	port           = ":50051"
)

func main() {

	lis, err := net.Listen("tcp", port)
	if err != nil {
		beeLogger.Log.Fatalf("failed to listen: %v", err)
	}

	beeLogger.Log.Success("gRPC server is running on " + port + " port.")

	// 启动grpc服务
	if err := initialize.RpcServer.Serve(lis); err != nil {
		beeLogger.Log.Fatalf("failed to serve: %v", err)

	}

}
